// ImprPick - Impression de fichiers spool issus de Pick pour mise en forme en utilisant les fonctions GDI.
// Copyright (c) 2000 et 2001, Thierry MARTIN.
// Version #1.00.
// Dernire version termine le dimanche 28 octobre 2001.

// Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon
// les termes de la Licence Publique Gnrale GNU publie par la Free Software
// Foundation (version 2 ou bien toute autre version ultrieure choisie par
// vous).
//
// Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
// GARANTIE, ni explicite ni implicite, y compris les garanties de
// commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
// Licence Publique Gnrale GNU pour plus de dtails.
//
// Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
// temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
// tats-Unis.

// Vous pouvez me joindre par e-mail  : imprpick@martin-thierry.nom.fr

// Versions :
//	  #1.00 : 28/10/01 : Imprime un fichier texte avec des commandes. La slection de la largeur des caractres est fonction
//	  							du nombre de caractres par ligne et la hauteur des caractres peut etre modifie. Les
//	  							semi-graphiques sont imprims  partir du jeu tendu des polices UNICODE.

// J'ai dvelopp ce programme en utilisant :
//   Le compilateur GCC version 2.95.2.
//   L'environnement CygWin32 version 1.3.2 disponible  http://www.cygwin.com/ (comprend GCC).

#include <Windows.H>

#include <IOStream.H>
#include <FStream.H>
#include <IOManip.H>
#include <Limits.H>
#include <Math.H>

#include <Chaine.H>

// Dclaration des types

typedef unsigned int uint;

// Dclaration des classes et structures

class TTabSHORT
{
private:
	short *tableau;
public:
	TTabSHORT ();
	size_t Longueur (size_t stNouvelleLongueur);
	~TTabSHORT ();
	short& operator [] (size_t stIndice);
};

struct TPoint : public POINT
{
	int operator == (const TPoint& point);
};

inline int TPoint::operator == (const TPoint& point)
{
	return x == point.x && y == point.y;
}

class TTabPoint
{
private:
	TPoint *tableau;
public:
	TTabPoint ();
	size_t Longueur (size_t stNouvelleLongueur);
	~TTabPoint ();
	TPoint& operator [] (size_t stIndice);
};

struct TPageCopie
{
	int			iDecalageX				 ;
	int			iDecalageY				 ;
	int			iHauteurImprimable	 ;
	short			sHauteurPapier			 ;
	int			iLargeurImprimable	 ;
	short			sLargeurPapier			 ;
	TChaine		chNomFichier			 ;
	short			sNumeroBac				 ;
	short			sNumeroPapier			 ;
	short			sOrientationImpression;
	TPageCopie* ppgcopSuivante			 ;
};

// Dfinition des constantes

short sHauteurPapierDefaut = 2970;	// 29,7 cm
short sLargeurPapierDefaut = 2100;	// 21 cm
const char tcTitreApplication [] = "Impression Pick";
enum ECopiesParProgramme
{
	cppPasCopies = 0,
	cppCopiesAssemblees = 1,
	cppCopiesALaSuite = 2
};

// Dclaration des variables

BOOL bAucuneErreur = TRUE;			// Indique s'il n'y a eu aucune erreur
int iCaracteresParLigne;			// Nombre de caractres par ligne (0 si valeur
											//prcise en 1/1000 cm)
uint uiCaractereX;					// Nombre de caractres imprims sur la ligne
											//courante
BOOL bChangePage;						// A la fin du mode commande il faut changer le
											//format de la page
BOOL bChangePolice;					// A la fin du mode commande il faut changer la
											//police
TChaine chCommande;					// Nom de la commande d'impression (mode
											//commande)
BOOL bCopiesAssemblees;				// Indicateur pour l'ordre des copies
											//(assembles ou non)
ECopiesParProgramme cppCourant;	// Comment le programme fait les copies en
											//envoyant plusieurs fois chaque page
HFONT hfCourante;						// Handle de la police courante
int iDecalageX;						// Dcalage des X en 1/1000 cm (marge gauche
											//calcule)
int iDecalageY;						// Dcalage des Y en 1/1000 cm (marge du haut
											//calcule)
HFONT hfDefaut;						// Handle de la police par dfaut (celle
											//utilise avant la premire slection)
TPageCopie* ppgcopDernierePage;	// Dernire page pour copies multiples
DWORD dwDevModeFieldsPossibles;	// Champs possibles lors de l'initialisation
											//de l'impression (DEVMODE)
BOOL bDocumentOuvert;				// Indique si StartDoc a t excut
char tcDossierTEMP [MAX_PATH];	// Nom du dossier pour les fichiers temporaires
BOOL bErreurSuppFichierTemp;		// Indique s'il y a eu une erreur lors de la
											//suppression d'un fichier temporaire
int iGrasPolice;						// Valeur de gras de la police
int iHauteurImprimable;				// Hauteur imprimable sur le papier 1/1000 cm
											//(hors marges)
int iHauteurMinPapier;				// Hauteur minimum du papier pour l'imprimante
											//en 1/100 cm
int iHauteurMaxPapier;				// Hauteur maximum du papier pour l'imprimante
											//en 1/100 cm
int iHauteurPolice;					// Hauteur demande pour la police en 1/1000 cm
											//(si iMultipleHauteurPolice est diffrent de 0
											//cette valeur est ignore)
short sHauteurPapier;				// Hauteur du papier en 1/100 cm (si le papier
											//est personnalis c'est la valeur donne par
											//la commande "LargeurPapier", sinon c'est la
											//largeur donne par les paramtres de
											//l'imprimante)
ifstream ifImpression;				// Fichier imprim
HDC hdcImprimante;					// Handle du device context de l'imprimante
int iInterligne;						// Interligne actuel en 1/1000 cm
int iInterligneMultiple;			// Interligne en multiple pour la police (0 si
											//valeur prcise en 1/1000 cm)
BOOL bItaliquePolice;				// Indicateur de police italique
int iLargeurCaractere;				// Largeur du caractre pour la police
											//slectionne (y compris l'espace laiss libre
											//entre les caractres)
int iLargeurImprimable;				// Largeur imprimable sur le papier 1/1000 cm
											//(hors marges)
int iLargeurMinPapier;				// Largeur minimum du papier pour l'imprimante
											//en 1/100 cm
int iLargeurMaxPapier;				// Largeur maximum du papier pour l'imprimante
											//en 1/100 cm
short sLargeurPapier;				// Largeur du papier en 1/100 cm (meme
											//remarque que pour sHauteurPapier)
int iLargeurPolice;					// Largeur demande pour la police en 1/1000 cm
											//(si iCaracteresParLigne est diffrent de 0
											//cette valeur est ignore)
short sMargeBas;						// Marge du bas de la page en 1/1000 cm (0 pour
											//obtenir la marge minimum)
short sMargeDroite;					// Marge  droite de la page en 1/1000 cm (0
											//pour obtenir la marge minimum)
short sMargeGauche;					// Marge  gauche de la page en 1/1000 cm (0
											//pour obtenir la marge minimum)
short sMargeHaut;						// Marge en haut de la page en 1/1000 cm (0
											//pour obtenir la marge minimum)
BOOL bModeCommande;					// Indique si le caractre en cours
											//d'impression est une commande
int iMultipleHauteurPolice;		// Hauteur demande pour la police en multiple
											//de la hauteur standard (cette variable
											//contient 0 si la hauteur est dfinie en
											//1/1000 cm dans la variable iHauteurPolice)
TChaine chNomBacDefini;				// Nom des bacs dfinis (en corresondance avec
											//leur numro)
short sNombreCopies;					// Nombre de copies demandes
DWORD dwNombreBacsDefinis;			// Nombre de bacs dfinis
DWORD dwNombrePapiersDefinis;		// Nombre de papiers dfinis
TChaine chNomFichierImpression;	// Nom du fichier qui est imprim
TChaine chNomImprimante;			// Nom de l'imprimante utilise
TChaine chNomPapierDefini;			// Nom des papiers dfinis (en correspondance
											//avec leur numro et leur nom)
TChaine chNomPolice;					// Nom de la police slectionne
short sNumeroBac;						// Numero du bac de sortie slectionn (0 si
											//bac par dfaut de l'imprimante)
TTabSHORT tsNumeroBacDefini;		// Numro des bacs dfinis (en correspondance
											//avec leur nom)
short sNumeroPapier;					// Numro du papier slectionne (0 si taille
											//personnalise)
TTabSHORT tsNumeroPapierDefini;	// Numro des papiers dfinis (en
											//correspondance avec leur nom et taille)
short sOrientationImpression;		// Orientation de l'impression
DWORD dwOrientationPaysage;		// Indique dans quel sens il faut tourner la
											//page pour obtenir le mode paysage
BOOL bPageVide;						// Indique si la page est vide, sinon des
											//caractres ont dj t imprims
BOOL bPapierPersoPossible;			// Indique s'il est possible de spcifier une
											//taille de papier
int iPositionX;						// Position dans la largeur (0 si le plus 
											//gauche de la ligne,  la marge, positif vers
											//la droite)
int iPositionY;						// Position dans la hauteur (0 si le plus en
											//haut de la page,  la marge, positif en
											//descendent)
TPageCopie* ppgcopPremierePage;	// Premire page pour copies multiples
HDC hdcSortie;							// Handle du device context du fichier EMF
											//(enhanced metafile) ou de l'imprimante qui
											//assure la sortie de la page (le fichier EMF
											//est utilis pour copies assembles)
BOOL bSoulignePolice;				// Indicateur de police souligne
TTabPoint tpoTaillePapierDefini;	// Tailles dfinies pour le papier (en
											//correspondance avec leur nom et numro)
TChaine chTitreDocument;			// Titre du document utilis pour StartDoc

// Prototypes

void EnregistreMessageErreur (const TChaine &message);
int ImprimeCopies ();
int ImprimePage ();
int ImprimePageEMF (HENHMETAFILE hmfPage, const RECT& reTaille);
BOOL MesureCentimetre (const TChaine &chValeur, int &iValeur,
							  uint uiNombreDecimales);
BOOL MesureCentimetre100 (const TChaine &chValeur, int &iValeur);
BOOL MesureCentimetre1000 (const TChaine &chValeur, int &iValeur);
int OuvreDocument ();
void OuvreFichierErreur (ofstream& ofErreur, HANDLE hmxNumeroFichier);
int SelectionPage ();
int SelectionPage (short sNouveauNumeroPapier, short sNouvelleLargeurPapier,
						 short sNouvelleHauteurPapier,
						 short sNouvelleOrientationImpression,
						 short sNouveauNumeroBac, short sNouveauNombreCopies,
						 short sCopiesAssemblees);
int SelectionPolice ();

// Fonction inline

inline BOOL MesureCentimetre100 (const TChaine &chValeur, int &iValeur)
{
	return MesureCentimetre (chValeur, iValeur, 2);
}

inline BOOL MesureCentimetre1000 (const TChaine &chValeur, int &iValeur)
{
	return MesureCentimetre (chValeur, iValeur, 3);
}

// Fonctions membres de classe

TTabSHORT::TTabSHORT ()
{
	tableau = 0;
}

size_t TTabSHORT::Longueur (size_t stNouvelleLongueur)
{
	if (tableau) delete tableau;
	tableau = (stNouvelleLongueur) ? (new short [stNouvelleLongueur]) : (NULL);
	return stNouvelleLongueur;
}

TTabSHORT::~TTabSHORT ()
{
	if (tableau) delete tableau;
}

short& TTabSHORT::operator [] (size_t stIndice)
{
	return tableau [stIndice];
}

TTabPoint::TTabPoint ()
{
	tableau = 0;
}

size_t TTabPoint::Longueur (size_t stNouvelleLongueur)
{
	if (tableau) delete tableau;
	tableau = (stNouvelleLongueur) ? (new TPoint [stNouvelleLongueur]) : (NULL);
	return stNouvelleLongueur;
}

TTabPoint::~TTabPoint ()
{
	if (tableau) delete tableau;
}

TPoint& TTabPoint::operator [] (size_t stIndice)
{
	return tableau [stIndice];
}

// Autres fonctions

void EnregistreMessageErreur (const TChaine& chMessage)
{
	static ofstream ofErreur;
	static BOOL bFichierOuvert = FALSE;

	bAucuneErreur = FALSE;
	if (!bFichierOuvert)
	{
		HANDLE hmxNumeroFichier = CreateMutex (NULL, FALSE,
			"Impression Pick.Numero fichier erreur");

		if (!hmxNumeroFichier)
		{
			DWORD dwErreur = GetLastError ();

			cout << "Erreur numro " << dwErreur << " lors de la cration"
					  " d'un mutex pendant la recherche du nom du fichier d'erreurs"
					  " lors de l'impression du fichier " <<
					  chNomFichierImpression << " sur l'imprimante " <<
					  chNomImprimante << ".\n";
		}
		else
		{
			OuvreFichierErreur (ofErreur, hmxNumeroFichier);
			CloseHandle (hmxNumeroFichier);
		}
		bFichierOuvert = TRUE;
	}
	if (ofErreur.rdbuf ()->is_open () && ofErreur.good ())
	{
		ofErreur << '\n' << chMessage.AnsiToOem ();
	}
	if (! ofErreur.rdbuf ()->is_open () || ofErreur.fail ())
	{
		cout << chMessage << ". Pandant l'impression du fichier " <<
				  chNomFichierImpression << " sur l'imprimante " <<
				  chNomImprimante << ".\n";
	}
}

int FinCommande ()
{
	TChaine chDerniereCommande = chCommande;
	chCommande = "";
	if (chDerniereCommande.AjusteBlancs ().Longueur ())
	{
		TChaine chNomCommande;
		TTailleChaine lchPositionEgal = chDerniereCommande.Position ('=');
		int iRetour ;
		TChaine chValeurParametres;

		if (lchPositionEgal)
		{
			chNomCommande = chDerniereCommande.Debut (lchPositionEgal - 1);
			chValeurParametres = chDerniereCommande.AuDela (lchPositionEgal + 1).AjusteBlancs ();
		}
		else
		{
			chNomCommande = chDerniereCommande;
		}
		chNomCommande = chNomCommande.Majuscules ().AjusteBlancs (TRUE, 2, TRUE);
		if (chNomCommande == TChaine ("AFFICHETAILLEPAGE"))
		{	// L'utilisation de cette commande provoque un saut de page si la page est vide.
			// Une solution serait d'ouvrir un document avec comme destination NULL.
			if (bPageVide)
			{
				iRetour = OuvreDocument ();
				if (iRetour) return iRetour;
				iRetour = SelectionPage ();
				if (iRetour) return iRetour;
//				cout << "StartPage\n";
				if (StartPage (hdcImprimante) <= 0)
				{
					DWORD dwErreur = GetLastError ();

					EnregistreMessageErreur (TChaine ("Erreur numro ") |
													 dwErreur | " au dbut de l'impression "
													 "d'une page");
					return -4;
				}
				hdcSortie = hdcImprimante;
				if (!SetMapMode (hdcSortie, MM_HIMETRIC))
				{
					EnregistreMessageErreur ("L'unit de mesure MM_HIMETRIC ne peux pas tre applique au contexte"
													 " d'impression.");
					return -4;
				}
			}
			iRetour = SelectionPolice ();
			if (iRetour) return iRetour;
			if (chValeurParametres.Longueur ())
			{
				cout << chValeurParametres << '/';
			}
			cout << (iLargeurImprimable / iLargeurCaractere) << '/' <<
					  (iHauteurImprimable / iInterligne) << '\n';
			if (bPageVide)
			{
//				cout << "EndPage\n";
				if (EndPage (hdcImprimante) <= 0)
				{
					DWORD dwErreur = GetLastError ();

					EnregistreMessageErreur (TChaine ("Erreur numro ") | dwErreur | "  la fin de l'impression d'une page");
					return -4;
				}
				hdcSortie = 0;
			}
		}
		else if (chNomCommande == TChaine ("BAC"))
		{
			short sNouveauBac = 0;

			if (chValeurParametres.Longueur ())
			{
				DWORD dwBac;

				chValeurParametres = chValeurParametres.Majuscules ();
				for (dwBac = 0; dwBac < dwNombreBacsDefinis; ++dwBac)
				{
					if (chValeurParametres == chNomBacDefini (dwBac + 1))
					{
						sNouveauBac = tsNumeroBacDefini [dwBac];
						break;
					}
				}
				if (!sNouveauBac)
				{
					EnregistreMessageErreur ("Le bac " | chValeurParametres | " n'existe pas pour l'imprimante,"
													 " la commande est ignore");
					return 0;
				}
			}
			iRetour = ImprimePage ();
			if (iRetour) return iRetour;
			sNumeroBac = sNouveauBac;
			bChangePage = TRUE;
		}
		else if (chNomCommande == TChaine ("COPIESASSEMBLEES"))
		{
			uint uiNouveauCopiesAssemblees;

			if (!chValeurParametres.Longueur ())
			{
				uiNouveauCopiesAssemblees = FALSE;
			}
			else if (!(chValeurParametres >> uiNouveauCopiesAssemblees) ||
							(uiNouveauCopiesAssemblees != FALSE && uiNouveauCopiesAssemblees != TRUE))
			{
				EnregistreMessageErreur ("La valeur " | chValeurParametres | " est incorrecte pour la commande"
												 " CopiesAssembles, la commande est ignore");
				return 0;
			}
			if (bCopiesAssemblees != BOOL (uiNouveauCopiesAssemblees))
			{
				iRetour = ImprimePage ();
				if (iRetour) return iRetour;
				iRetour = ImprimeCopies ();
				if (iRetour) return iRetour;
				bCopiesAssemblees = BOOL (uiNouveauCopiesAssemblees);
				bChangePage = TRUE;
			}
		}
		else if (chNomCommande == TChaine ("GRAS"))
		{
			int iNouveauGras;

			if (!chValeurParametres.Longueur ())
			{
				iNouveauGras = FW_DONTCARE;
			}
			else if (!(chValeurParametres >> iNouveauGras) || (iNouveauGras != 0 &&
						 (iNouveauGras <= 100 || iNouveauGras >= 900)))
			{
				EnregistreMessageErreur ("La valeur " | chValeurParametres |
												 " est incorrecte pour la commande Gras. "
												 "La commande est ignore");
				return 0;
			}
			iGrasPolice = iNouveauGras;
			bChangePolice = TRUE;
		}
		else if (chNomCommande == TChaine ("INTERLIGNE"))
		{
			if (!chValeurParametres.Longueur ())
			{	// Par dfaut
				iInterligneMultiple = 1;
			}
			else if (chValeurParametres [1] == '*')
			{	// Multiple
				int nouveauMultiple;
				if (!(chValeurParametres.AuDela (2) >> nouveauMultiple) || nouveauMultiple == 0)
				{
					EnregistreMessageErreur ("La valeur " | chValeurParametres | " est incorrecte pour la commande Interligne, "
													 "la commande est ignore");
					return 0;
				}
				iInterligneMultiple = nouveauMultiple;
				bChangePolice = TRUE;
			}
			else
			{	// En centimtres
				int nouvelInterligne;
				if (!MesureCentimetre1000 (chValeurParametres, nouvelInterligne) || nouvelInterligne == 0)
				{
					EnregistreMessageErreur ("La valeur " | chValeurParametres | " est incorrecte pour la commande Interligne, "
													 "la commande est ignore");
					return 0;
				}
				iInterligne = nouvelInterligne;
				iInterligneMultiple = 0;
			}
		}
		else if (chNomCommande == TChaine ("ITALIQUE"))
		{
			unsigned int uiNouvelItalique;

			if (!chValeurParametres.Longueur ())
			{
				uiNouvelItalique = FALSE;
			}
			else if (!(chValeurParametres >> uiNouvelItalique) || (uiNouvelItalique != FALSE && uiNouvelItalique != TRUE))
			{
				EnregistreMessageErreur ("La valeur " | chValeurParametres | " est incorrecte pour la commande Italique, "
												 "la commande est ignore");
				return 0;
			}
			bItaliquePolice = uiNouvelItalique;
			bChangePolice = TRUE;
		}
		else if (chNomCommande == TChaine ("HAUTEURCARACTERE"))
		{
			if (!chValeurParametres.Longueur ())
			{	// Par dfaut (hauteur standard)
				iMultipleHauteurPolice = 80;
			}
			else if (chValeurParametres [1] == '*')
			{	// Hauteur multiple
				int iNouveauMultiple;
				if (!MesureCentimetre1000 (chValeurParametres.AuDela (2),
													iNouveauMultiple) ||
					 iNouveauMultiple <= 0)
				{
					EnregistreMessageErreur ("La valeur " | chValeurParametres |
													 " est incorrecte pour la commande"
													 " HauteurCaractre."
													 " La commande est ignore.");
					return 0;
				}
				iMultipleHauteurPolice = iNouveauMultiple;
			}
			else
			{	// Hauteur d'un caractre en centimtres
				int iNouvelleHauteur;
				if (!MesureCentimetre1000 (chValeurParametres, iNouvelleHauteur) ||
					 iNouvelleHauteur <= 0)
				{
					EnregistreMessageErreur ("La valeur " | chValeurParametres |
													 " est incorrecte pour la commande"
													 " HauteurCaractre."
													 " La commande est ignore.");
					return 0;
				}
				iHauteurPolice = iNouvelleHauteur;
				iMultipleHauteurPolice = 0;
			}
			bChangePolice = TRUE;
		}
		else if (chNomCommande == TChaine ("HAUTEURPAPIER"))
		{
			short sNouvelleHauteur;

			if (!chValeurParametres.Longueur () && bPapierPersoPossible)
			{
				sNouvelleHauteur = (sOrientationImpression == DMORIENT_PORTRAIT) ? (sHauteurPapierDefaut) : (sLargeurPapierDefaut);
			}
			else if (!bPapierPersoPossible || !(chValeurParametres >> sNouvelleHauteur) ||
				  		sNouvelleHauteur < iHauteurMinPapier || sNouvelleHauteur > iHauteurMaxPapier)
			{
				EnregistreMessageErreur ("La valeur " | chValeurParametres | " est incorrecte pour la commande HauteurPapier,"
												 " la commande est ignore");
				return 0;
			}
			iRetour = ImprimePage ();
			if (iRetour) return iRetour;
			if (sNumeroPapier)
			{
				sNumeroPapier = 0;
				sLargeurPapier = (sOrientationImpression == DMORIENT_PORTRAIT) ? (sLargeurPapierDefaut) : (sHauteurPapierDefaut);
			}
			sHauteurPapier = sNouvelleHauteur;
			bChangePage = TRUE;
		}
		else if (chNomCommande == TChaine ("LARGEURCARACTERE"))
		{
			if (!chValeurParametres.Longueur ())
			{	// Par dfaut (80 colonnes)
				iCaracteresParLigne = 80;
			}
			else if (chValeurParametres [1] == '*')
			{	// Nombre de caractres par ligne
				int iNouveauMultiple;
				if (!(chValeurParametres.AuDela (2) >> iNouveauMultiple) || iNouveauMultiple <= 0)
				{
					EnregistreMessageErreur ("La valeur " | chValeurParametres | " est incorrecte pour la commande LargeurCaractre."
											" La commande est ignore.");
					return 0;
				}
				iCaracteresParLigne = iNouveauMultiple;
			}
			else
			{	// Largeur d'un caractre en centimtres
				int iNouvelleLargeur;
				if (!MesureCentimetre1000 (chValeurParametres, iNouvelleLargeur) || iNouvelleLargeur <= 0)
				{
					EnregistreMessageErreur ("La valeur " | chValeurParametres | " est incorrecte pour la commande LargeurCaractre."
											" La commande est ignore.");
					return 0;
				}
				iLargeurPolice = iNouvelleLargeur;
				iCaracteresParLigne = 0;
			}
			bChangePolice = TRUE;
		}
		else if (chNomCommande == TChaine ("LARGEURPAPIER"))
		{
			short sNouvelleLargeur;

			if (!chValeurParametres.Longueur () && bPapierPersoPossible)
			{
				sNouvelleLargeur = (sOrientationImpression == DMORIENT_PORTRAIT) ? (sLargeurPapierDefaut) : (sHauteurPapierDefaut);
			}
			else if (!bPapierPersoPossible || !(chValeurParametres >> sNouvelleLargeur) || sNouvelleLargeur < iLargeurMinPapier ||
							sNouvelleLargeur > iLargeurMaxPapier)
			{
				EnregistreMessageErreur ("La valeur " | chValeurParametres | " est incorrecte pour la commande LargeurPapier."
										" La commande est ignore.");
				return 0;
			}
			iRetour = ImprimePage ();
			if (iRetour) return iRetour;
			if (sNumeroPapier)
			{
				sNumeroPapier = 0;
				sHauteurPapier = (sOrientationImpression == DMORIENT_PORTRAIT) ? (sHauteurPapierDefaut) : (sLargeurPapierDefaut);
			}
			sLargeurPapier = sNouvelleLargeur;
			bChangePage = TRUE;
		}
		else if (chNomCommande == TChaine ("MARGEBAS"))
		{
			short sNouvelleMarge;

			if (!chValeurParametres.Longueur ())
			{
				sNouvelleMarge = 0;
			}
			else if (!(chValeurParametres >> sNouvelleMarge) || sNouvelleMarge < 0)
			{
				EnregistreMessageErreur ("La valeur " | chValeurParametres | " est incorrecte pour la commande MargeBas."
										" La commande est ignore.");
				return 0;
			}
			iRetour = ImprimePage ();
			if (iRetour) return iRetour;
			sMargeBas = sNouvelleMarge;
			bChangePage = TRUE;
		}
		else if (chNomCommande == TChaine ("MARGEDROITE"))
		{
			short sNouvelleMarge;

			if (!chValeurParametres.Longueur ())
			{
				sNouvelleMarge = 0;
			}
			else if (!(chValeurParametres >> sNouvelleMarge) || sNouvelleMarge < 0)
			{
				EnregistreMessageErreur ("La valeur " | chValeurParametres | " est incorrecte pour la commande MargeDroite."
										" La commande est ignore.");
				return 0;
			}
			iRetour = ImprimePage ();
			if (iRetour) return iRetour;
			sMargeDroite = sNouvelleMarge;
			bChangePage = TRUE;
		}
		else if (chNomCommande == TChaine ("MARGEGAUCHE"))
		{
			short sNouvelleMarge;

			if (!chValeurParametres.Longueur ())
			{
				sNouvelleMarge = 0;
			}
			else if (!(chValeurParametres >> sNouvelleMarge) || sNouvelleMarge < 0)
			{
				EnregistreMessageErreur ("La valeur " | chValeurParametres | " est incorrecte pour la commande MargeGauche."
										" La commande est ignore.");
				return 0;
			}
			iRetour = ImprimePage ();
			if (iRetour) return iRetour;
			sMargeGauche = sNouvelleMarge;
			bChangePage = TRUE;
		}
		else if (chNomCommande == TChaine ("MARGEHAUT"))
		{
			short sNouvelleMarge;

			if (!chValeurParametres.Longueur ())
			{
				sNouvelleMarge = 0;
			}
			else if (!(chValeurParametres >> sNouvelleMarge) || sNouvelleMarge < 0)
			{
				EnregistreMessageErreur ("La valeur " | chValeurParametres | " est incorrecte pour la commande MargeHaut."
										" La commande est ignore.");
				return 0;
			}
			iRetour = ImprimePage ();
			if (iRetour) return iRetour;
			sMargeHaut = sNouvelleMarge;
			bChangePage = TRUE;
		}
		else if (chNomCommande == TChaine ("NOMBRECOPIES"))
		{
			short sNouvellesCopies;

			if (!chValeurParametres.Longueur ())
			{
				sNouvellesCopies = 1;
			}
			else if (!(chValeurParametres >> sNouvellesCopies) || sNouvellesCopies <= 0)
			{
				EnregistreMessageErreur ("La valeur " | chValeurParametres | " est incorrecte pour la commande NombreCopies."
										" La commande est ignore.");
				return 0;
			}
			if (sNombreCopies != sNouvellesCopies)
			{
				iRetour = ImprimePage ();
				if (iRetour) return iRetour;
				iRetour = ImprimeCopies ();
				if (iRetour) return iRetour;
				sNombreCopies = sNouvellesCopies;
				bChangePage = TRUE;
			}
		}
		else if (chNomCommande == TChaine ("ORIENTATION"))
		{
			if (!(dwDevModeFieldsPossibles & DM_ORIENTATION))
			{
				EnregistreMessageErreur ("La commande Orientation n'est pas utilisable avec l'imprimante " | chNomImprimante |
												 ". La commande est ignore.");
				return 0;
			}

			short sNouvelleOrientation;

			if (!chValeurParametres.Longueur ())
			{
				sNouvelleOrientation = DMORIENT_PORTRAIT;
			}
			else
			{
				chValeurParametres = chValeurParametres.Majuscules ();
				if (chValeurParametres == "PORTRAIT")
				{
					sNouvelleOrientation = DMORIENT_PORTRAIT;
				}
				else if (chValeurParametres == "PAYSAGE")
				{
					sNouvelleOrientation = DMORIENT_LANDSCAPE;
				}
				else
				{
					EnregistreMessageErreur ("La valeur " | chValeurParametres | " est incorrecte pour la commande Orientation."
											" La commande est ignore.");
					return 0;
				}
			}
			if (sOrientationImpression != sNouvelleOrientation)
			{
				iRetour = ImprimePage ();
				if (iRetour) return iRetour;
				if ((dwOrientationPaysage == 90) ^
					 (sNouvelleOrientation == DMORIENT_PORTRAIT))
				{
					short margeTemp = sMargeGauche;
					sMargeGauche = sMargeBas; sMargeBas = sMargeDroite;
					sMargeDroite = sMargeHaut; sMargeHaut = margeTemp;
				}
				else
				{
					short margeTemp = sMargeGauche;
					sMargeGauche = sMargeHaut; sMargeHaut = sMargeDroite;
					sMargeDroite = sMargeBas; sMargeBas = margeTemp;
				}
				short dimensionTemp = sLargeurPapier;
				sLargeurPapier = sHauteurPapier; sHauteurPapier = dimensionTemp;
				sOrientationImpression = sNouvelleOrientation;
				bChangePage = TRUE;
			}
		}
		else if (chNomCommande == TChaine ("PAPIER"))
		{
			short sNouveauPapier = 0;
			POINT poTaillePapier		;

			if (chValeurParametres.Longueur ())
			{
				DWORD dwPapier;

				chValeurParametres = chValeurParametres.Majuscules ();
				for (dwPapier = 0; dwPapier < dwNombrePapiersDefinis; ++dwPapier)
				{
					if (chValeurParametres == chNomPapierDefini (dwPapier + 1))
					{
						sNouveauPapier = tsNumeroPapierDefini [dwPapier]; poTaillePapier = tpoTaillePapierDefini [dwPapier];
						break;
					}
				}
				if (!sNouveauPapier)
				{
					EnregistreMessageErreur ("Le papier " | chValeurParametres | " n'existe pas pour l'imprimante " | chNomImprimante |"."
											" La commande est ignore.");
					return 0;
				}
			}
			else
			{
				if (dwNombrePapiersDefinis)
				{
					DWORD dwPapier;

					for (dwPapier = 0; dwPapier < dwNombrePapiersDefinis; ++dwPapier)
					{
						if (tsNumeroPapierDefini [dwPapier] == DMPAPER_A4)
						{
							sNouveauPapier = DMPAPER_A4; poTaillePapier = tpoTaillePapierDefini [dwPapier];
							break;
						}
					}
				}
			}
			iRetour = ImprimePage ();
			if (iRetour) return iRetour;
			sNumeroPapier = sNouveauPapier;
			if (sNouveauPapier)
			{
				if (sOrientationImpression == DMORIENT_PORTRAIT)
				{
					sHauteurPapier = short (poTaillePapier.y);
					sLargeurPapier = short (poTaillePapier.x);
				}
				else
				{
					sHauteurPapier = short (poTaillePapier.x);
					sLargeurPapier = short (poTaillePapier.y);
				}
			}
			else
			{	// Papier par dfaut sur une imprimante qui ne possde pas de codes de papiers
				sHauteurPapier = (sOrientationImpression == DMORIENT_PORTRAIT) ? (sHauteurPapierDefaut) : (sLargeurPapierDefaut);
				sLargeurPapier = (sOrientationImpression == DMORIENT_PORTRAIT) ? (sLargeurPapierDefaut) : (sHauteurPapierDefaut);
			}
			bChangePage = TRUE;
		}
		else if (chNomCommande == TChaine ("POLICE"))
		{
			chNomPolice = chValeurParametres;
			bChangePolice = TRUE;
		}
		else if (chNomCommande == TChaine ("SOULIGNE"))
		{
			unsigned int uiNouveauSouligne;

			if (!chValeurParametres.Longueur ())
			{
				uiNouveauSouligne = FALSE;
			}
			else if (!(chValeurParametres >> uiNouveauSouligne) || (uiNouveauSouligne != FALSE && uiNouveauSouligne != TRUE))
			{
				EnregistreMessageErreur ("La valeur " | chValeurParametres | " est incorrecte pour la commande Soulign."
												 " La commande est ignore.");
				return 0;
			}
			bSoulignePolice = uiNouveauSouligne;
			bChangePolice = TRUE;
		}
		else if (chNomCommande == TChaine ("TITREDOCUMENT"))
		{
			chTitreDocument = chValeurParametres;
		}
		else
		{
			EnregistreMessageErreur ("La commande de contrle " | chNomCommande | " est inconnue et ignore pour la ligne de "
											 "commande " | chDerniereCommande | ".");
		}
	}
	return 0;
}

int ImprimeCopies ()
{
	if (cppCourant == cppCopiesAssemblees)
	{
		// Impression des exemplaires
		short sExemplaire;

		for (sExemplaire = 2 ; sExemplaire <= sNombreCopies ; ++sExemplaire)
		{
			TPageCopie* ppgcopCourante;
			for (ppgcopCourante = ppgcopPremierePage ; ppgcopCourante ; ppgcopCourante = ppgcopCourante->ppgcopSuivante)
			{
				int iRetour = SelectionPage (ppgcopCourante->sNumeroPapier, ppgcopCourante->sLargeurPapier,
													  ppgcopCourante->sHauteurPapier, ppgcopCourante->sOrientationImpression,
													  ppgcopCourante->sNumeroBac, 1, DMCOLLATE_FALSE);
				if (iRetour) return iRetour;

				TTamponCaracteres tampcarNomFichier (ppgcopCourante->chNomFichier, ftcASCIIZ);
				HENHMETAFILE hmfPage = GetEnhMetaFile (tampcarNomFichier);

				if (hmfPage)
				{
					RECT reTaille = {0, 0,
						ppgcopCourante->iDecalageX + ppgcopCourante->iLargeurImprimable,
						-(ppgcopCourante->iDecalageY + ppgcopCourante->iHauteurImprimable)};

					iRetour = ImprimePageEMF (hmfPage, reTaille);
					if (iRetour) return iRetour;
					if (!DeleteEnhMetaFile (hmfPage))
					{
						EnregistreMessageErreur (TChaine ("Erreur lors de la desctruction du metafile pendant "
														 "l'impression des exemplaires supplmentaires d'une page du fichier\n"
														 "") | chNomFichierImpression | "\n"
														 "sur l'imprimante " | chNomImprimante | ".");
						return -4;
					}
				}
				else
				{
					EnregistreMessageErreur (TChaine ("Le fichier metafile ") | ppgcopCourante->chNomFichier |" n'existe plus lors de "
										"l'impression des autres exemplaires. Les derniers exemplaires de cette page ne sont pas"
										" dits.");
				}
			}
		}
	}
	// Suppression des fichiers
	while (ppgcopPremierePage)
	{
		TPageCopie* ppgcopSuivante = ppgcopPremierePage->ppgcopSuivante;
		TTamponCaracteres tampcarNomFichier (ppgcopPremierePage->chNomFichier, ftcASCIIZ);

		if (!DeleteFile (tampcarNomFichier) &&
			 GetLastError () != ERROR_FILE_NOT_FOUND)
		{
			bErreurSuppFichierTemp = TRUE;
		}
		delete ppgcopPremierePage;
		ppgcopPremierePage = ppgcopSuivante;
	}
	ppgcopDernierePage = 0;
	return 0;
}

int ImprimeFichier ()
{
	int iRetour;
	unsigned char ucLu;
	while (ifImpression.get (ucLu).good ())
	{
		if (ucLu < ' ')
		{	// Contrle
			switch (ucLu)
			{
			case '\x00':	// Ignor
				break;
			case '\x01':	// Dbut commande
				bModeCommande = TRUE;
				chCommande = "";
				break;
			case '\x02':	// Fin commande
				iRetour = FinCommande ();
				if (iRetour) return iRetour;
				bModeCommande = FALSE;
				break;
			default:
				if (bModeCommande)
				{
					switch (ucLu)
					{
					case '\n':
					case '\r':
						iRetour = FinCommande ();
						if (iRetour) return iRetour;
						break;
					case '\f':
						iRetour = FinCommande ();
						if (iRetour) return iRetour;
						bModeCommande = FALSE;
						iRetour = ImprimePage ();
						if (iRetour) return iRetour;
						break;
					default:
						EnregistreMessageErreur ("Caractre de contrle " |
							TChaine (int (ucLu)) | " incorrect en mode commande.");
						break;
					}
				}
				else
				{
					switch (ucLu)
					{
					case '\0':
						break;
					case '\b':
						iPositionX -= iLargeurCaractere;
						if (iPositionX < 0) iPositionX = 0;
						if (uiCaractereX > 0) uiCaractereX -= 1;
						break;
					case '\t':
						{
						uint uiNombreCaracteres = 8 - uiCaractereX % 8;

						uiCaractereX += uiNombreCaracteres;
						iPositionX += iLargeurCaractere * uiNombreCaracteres;
						}
						break;
					case '\n':
						iPositionY += iInterligne;
						if (iPositionY >= iHauteurImprimable)
						{
							int iPosXAv = iPositionX;
							unsigned int uiCarXAv = uiCaractereX;

							iRetour = ImprimePage ();
							if (iRetour) return iRetour;
							iPositionX = iPosXAv; uiCaractereX = uiCarXAv;
						}
						break;
					case '\f':
						iRetour = ImprimePage ();
						if (iRetour) return iRetour;
						break;
					case '\r':
						iPositionX = 0; uiCaractereX = 0;
						break;
					default:
						EnregistreMessageErreur ("Caractre de contrle " |
							TChaine (int (ucLu)) | " incorrect en mode impression.");
						break;
					}
				}
			}
		}
		else if (bModeCommande)
		{
			OemToCharBuff ((char*) &ucLu, (char*) &ucLu, 1);
			chCommande |= ucLu;
		}
		else
		{	// caractres affichables
			if (bPageVide)
			{
				iRetour = OuvreDocument ();
				if (iRetour) return iRetour;
				if (bChangePage)
				{
					iRetour = SelectionPage ();
					if (iRetour) return iRetour;
				}
				if (cppCourant)
				{
					if (!SetMapMode (hdcImprimante, MM_HIMETRIC))
					{
						EnregistreMessageErreur ("L'unit de mesure MM_HIMETRIC ne peux pas tre applique contexte"
														 " d'impression.");
						return -4;
					}
					RECT reTaille = {0, 0, iLargeurImprimable + iDecalageX, iHauteurImprimable + iDecalageY};

					hdcSortie = CreateEnhMetaFile (hdcImprimante, NULL, &reTaille, NULL);
					if (!hdcSortie)
					{
						EnregistreMessageErreur ("Il n'est pas possible de crer l'EMF pour l'dition multi-exemplaires");
						return -4;
					}
				}
				else
				{
//					cout << "StartPage\n";
					if (StartPage (hdcImprimante) <= 0)
					{
						DWORD dwErreur = GetLastError ();

						EnregistreMessageErreur (TChaine ("Erreur numro ") |
														 dwErreur | " au dbut de "
														 "l'impression d'une page");
						return -4;
					}
					hdcSortie = hdcImprimante;
				}
				if (!SetMapMode (hdcSortie, MM_HIMETRIC))
				{
					EnregistreMessageErreur ("L'unit de mesure MM_HIMETRIC ne peux "
													 "pas tre applique au contexte "
													 "d'impression");
					return -4;
				}
				bChangePolice = TRUE;
			}
			if (bChangePolice)
			{
				iRetour = SelectionPolice ();
				if (iRetour) return iRetour;
			}
			if (iPositionX + iLargeurCaractere >= iLargeurImprimable)
			{
				iPositionX = 0; uiCaractereX = 0;
				iPositionY += iInterligne;
				if (iPositionY >= iHauteurImprimable)
				{
					iRetour = ImprimePage ();
					if (iRetour) return iRetour;
				}
			}

			size_t stLongueurMB = MultiByteToWideChar (437, 0, (char*) &ucLu, 1, NULL, 0);
			wchar_t* pwcAImprimer = new wchar_t [stLongueurMB];

			MultiByteToWideChar (437, 0, (char*) &ucLu, 1, pwcAImprimer, stLongueurMB);
			TextOutW (hdcSortie, iPositionX + iDecalageX, -(iPositionY + iDecalageY), pwcAImprimer, stLongueurMB);
			bPageVide = FALSE;
			iPositionX += iLargeurCaractere; uiCaractereX += 1;
			delete pwcAImprimer;
		}
	}
	if (!ifImpression.eof ())
	{
		ifImpression.clear ();
		EnregistreMessageErreur ("Erreur numro lors de la lecture du fichier "
										 "d'impression");
		return -1;
	}
	ifImpression.clear ();
	return 0;
}

int ImprimePage ()
{
	if (!bPageVide)
	{
		// Restitue la police par dfaut
		if (hfCourante)
		{
			DeleteObject (SelectObject (hdcSortie, hfDefaut));
			hfCourante = 0;
		}
		hfDefaut = 0;
		bChangePolice = TRUE;

		// Fin de page
		if (cppCourant)
		{
			// Edition de plusieurs exemplaires par programme
			short sCopiesSuite;

			HENHMETAFILE hmfPage = CloseEnhMetaFile (hdcSortie);
			if (bCopiesAssemblees)
			{
				char tcNomFichier [MAX_PATH];

				if (!GetTempFileName (tcDossierTEMP, "IPK", 0, tcNomFichier))
				{
					DWORD dwErreur = GetLastError ();

					EnregistreMessageErreur (TChaine ("Erreur numro ") | dwErreur | " lors de la recherche du nom du "
													 "fichier metafile temporaire d'une page");
					return -4;
				}

				HENHMETAFILE hmfFichier = CopyEnhMetaFile (hmfPage, tcNomFichier);

				if (!hmfFichier)
				{
					DWORD dwErreur = GetLastError ();

					DeleteFile (tcNomFichier);
					EnregistreMessageErreur (TChaine ("Erreur numro ") | dwErreur | " lors de la cration du fichier "
													 "metafile d'une page");
					return -4;
				}
				if (!DeleteEnhMetaFile (hmfFichier))
				{
					EnregistreMessageErreur ("Erreur lors de la desctruction de l'identifiant du metafile fichier d'une page");
				}

				TPageCopie* ppgcopNouvellePage = new TPageCopie;

				ppgcopNouvellePage->iDecalageX = iDecalageX;
				ppgcopNouvellePage->iDecalageY = iDecalageY;
				ppgcopNouvellePage->iHauteurImprimable = iHauteurImprimable;
				ppgcopNouvellePage->sHauteurPapier = sHauteurPapier;
				ppgcopNouvellePage->iLargeurImprimable = iLargeurImprimable;
				ppgcopNouvellePage->sLargeurPapier = sLargeurPapier;
				ppgcopNouvellePage->chNomFichier = tcNomFichier;
				ppgcopNouvellePage->sNumeroBac = sNumeroBac;
				ppgcopNouvellePage->sNumeroPapier = sNumeroPapier;
				ppgcopNouvellePage->sOrientationImpression = sOrientationImpression;
            ppgcopNouvellePage->ppgcopSuivante = 0;
				if (ppgcopDernierePage) ppgcopDernierePage->ppgcopSuivante = ppgcopNouvellePage;
				ppgcopDernierePage = ppgcopNouvellePage;
				if (!ppgcopPremierePage) ppgcopPremierePage = ppgcopNouvellePage;
				sCopiesSuite = 1;
			}
			else
			{
				sCopiesSuite = sNombreCopies;
			}
			short sExemplaire;
			RECT reTaille = {0, 0, iLargeurImprimable + iDecalageX, -(iHauteurImprimable + iDecalageY)};

			for (sExemplaire = 1; sExemplaire <= sCopiesSuite; ++sExemplaire)
			{
				int iRetour = ImprimePageEMF (hmfPage, reTaille);
				if (iRetour) return iRetour;
			}
			if (!DeleteEnhMetaFile (hmfPage))
			{
				EnregistreMessageErreur ("Erreur lors de la desctruction du metafile d'une page");
				return -4;
			}
		}
		else
		{
//			cout << "EndPage\n";
			if (EndPage (hdcImprimante) <= 0)
			{
				DWORD dwErreur = GetLastError ();

				EnregistreMessageErreur (TChaine ("Erreur numro ") | dwErreur | "  la fin de l'impression d'une page");
				return -4;
			}
		}
		iPositionX = iPositionY = 0; uiCaractereX = 0;
		bPageVide = TRUE;
		hdcSortie = 0;
	}
	return 0;
}

int ImprimePageEMF (HENHMETAFILE hmfPage, const RECT& reTaille)
{
//	cout << "StartPage\n";
	if (StartPage (hdcImprimante) <= 0)
	{
		DWORD dwErreur = GetLastError ();

		EnregistreMessageErreur (TChaine ("Erreur numro ") | dwErreur |
										 " au dbut de l'impression d'une page "
										 "multi-exemplaires");
		return -4;
	}
	if (!SetMapMode (hdcImprimante, MM_HIMETRIC))
	{
		EnregistreMessageErreur ("L'unit de mesure MM_HIMETRIC ne peut pas tre applique  l'imprimante");
		return -4;
	}
	if (!PlayEnhMetaFile (hdcImprimante, hmfPage, &reTaille))
	{
		DWORD dwErreur = GetLastError ();

		EnregistreMessageErreur (TChaine ("Erreur numro ") | dwErreur |
										 " lors de l'impression d'une page "
										 "multi-exemplaires");
		return -4;
	}
//	cout << "EndPage\n";
	if (EndPage (hdcImprimante) <= 0)
	{
		DWORD dwErreur = GetLastError ();
		EnregistreMessageErreur (TChaine ("Erreur numro ") | dwErreur | "  la fin de l'impression d'une page "
										 "multi-exemplaires");
		return -4;
	}
	return 0;
}

BOOL LectureLigneCommande (int argc, char* argv[])
{
	if (argc != 3) return FALSE;
	chNomImprimante = argv [1];
	chNomFichierImpression = argv [2];
	if (chNomImprimante [1] == '"')
	{
		if (chNomImprimante [chNomImprimante.Longueur ()] != '"') return FALSE;
		chNomImprimante = chNomImprimante.Milieu (2, chNomImprimante.Longueur () - 2);
	}
	if (!chNomImprimante.Longueur ()) return FALSE;
	if (chNomFichierImpression [1] == '"')
	{
		if (chNomFichierImpression [chNomFichierImpression.Longueur ()] != '"') return FALSE;
		chNomFichierImpression = chNomFichierImpression.Milieu (2, chNomFichierImpression.Longueur () - 2);
	}
	if (!chNomFichierImpression.Longueur ()) return FALSE;
	return TRUE;
}

BOOL MesureCentimetre (const TChaine &chValeur, int &iValeur, uint uiNombreDecimales)
{
	TTailleChaine lchPositionDecimal = chValeur.Position ('.');
	int iDiviseurDecimales = int (pow (10, uiNombreDecimales));

	if (!lchPositionDecimal)
	{
		lchPositionDecimal = chValeur.Position (',');
	}

	TChaine chDecimal, chEntier;

	if (lchPositionDecimal)
	{
		chEntier = chValeur.Debut (lchPositionDecimal - 1);
		chDecimal = chValeur.AuDela (lchPositionDecimal + 1);
	}
	else
	{
		chEntier = chValeur;
	}
	if (!(chEntier >> iValeur) || iValeur <= INT_MIN / iDiviseurDecimales || iValeur >= INT_MAX / iDiviseurDecimales)
	{
		return FALSE;
	}
	iValeur *= iDiviseurDecimales;
	if (chDecimal.Longueur ())
	{
		int iDecimal;

		if (chDecimal.Longueur () > uiNombreDecimales ||
			 !(chDecimal >> iDecimal) || iDecimal < 0 ||
			 iDecimal >= iDiviseurDecimales)
		{
			return FALSE;
		}
		iDecimal *= int (pow (10, uiNombreDecimales - chDecimal.Longueur ()));
		if (iDecimal >= iDiviseurDecimales)
		{
			return FALSE;
		}
		iValeur += iDecimal;
	}
	return TRUE;
}
int OuvreDocument ()
{
	if (!bDocumentOuvert)
	{
		TTamponCaracteres tcarTitreDocument (chTitreDocument, ftcASCIIZ);

		DOCINFO docinfo = {sizeof (DOCINFO),
								 (chTitreDocument.Longueur ()) ?  ((const char *) tcarTitreDocument) : (tcTitreApplication),
								 NULL, NULL, 0};

//		cout << "StartDoc\n";
		if (StartDoc (hdcImprimante, &docinfo) <= 0)
		{
			DWORD dwErreur = GetLastError ();
			EnregistreMessageErreur (TChaine ("Erreur numro ") | dwErreur | " au dbut de l'impression");
			return -4;
		}
		bDocumentOuvert = TRUE;
	}
	return 0;
}

void OuvreFichierErreur (ofstream& ofErreur, HANDLE hmxNumeroFichier)
{
	DWORD dwOpenedCreated;
	HKEY hkFichierErreurs;
	const char tcCleFichierErreurs [] = 
		"Software\\Thierry MARTIN\\Impression Pick\\Fichier erreurs";
	LONG lRetour = RegCreateKeyEx (HKEY_LOCAL_MACHINE, tcCleFichierErreurs, 0,
											 "", REG_OPTION_NON_VOLATILE,
											 KEY_QUERY_VALUE | KEY_SET_VALUE, NULL,
											 &hkFichierErreurs, &dwOpenedCreated);

	if (lRetour != ERROR_SUCCESS)
	{
		cout << "Erreur numro " << lRetour << " lors de la recherche de la cl "
			  << tcCleFichierErreurs << " dans la base de registre, pendant "
				  "l'impression du fichier " << chNomFichierImpression <<
				  " sur l'imprimante " << chNomImprimante << ".\n";
		return;
	}

	char tcDossierFichier [MAX_PATH];
	DWORD dwType;
	DWORD dwLongueur = MAX_PATH;
	const char tcValeurDossier [] = "Dossier";

	if (RegQueryValueEx (hkFichierErreurs, tcValeurDossier, 0, &dwType,
								(BYTE*) tcDossierFichier, &dwLongueur) !=
		 ERROR_SUCCESS || dwType != REG_SZ || tcDossierFichier [0] == '\0')
	{
		strcpy (tcDossierFichier, ".");
	}
	if (tcDossierFichier [strlen (tcDossierFichier) - 1] != '\\')
	{
		if (strlen (tcDossierFichier) + 1 >= MAX_PATH)
		{
			cout << "Le nom du fichier d'erreurs est trop long pour tre cr lors de l'impression du fichier " <<
					  chNomFichierImpression << " sur l'imprimante " << chNomImprimante << ".\n";
			RegCloseKey (hkFichierErreurs);
			return;
		}
		strcat (tcDossierFichier, "\\");
	}

	DWORD dwFileAttributes = GetFileAttributes (tcDossierFichier);

	if (dwFileAttributes == 0xFFFFFFFF || (!dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
	{
		cout << "Le dossier " << tcDossierFichier << " n'existe pour la cration du fichier d'erreur lors de l'impression "
				  "du fichier " << chNomFichierImpression << " sur l'imprimante " << chNomImprimante << ".\n";
		RegCloseKey (hkFichierErreurs);
		return;
	}
	WaitForSingleObject (hmxNumeroFichier, INFINITE);

	DWORD dwNumeroFichier;
	const char tcValeurNumero [] = "Numro chrono";

	if (RegQueryValueEx (hkFichierErreurs, tcValeurNumero, 0, &dwType, (BYTE*) &dwNumeroFichier, &dwLongueur) != ERROR_SUCCESS ||
		 dwType != REG_DWORD || dwLongueur != sizeof (dwNumeroFichier))
	{
		dwNumeroFichier = 0;
	}
	do
	{
		ofErreur.clear ();
		dwNumeroFichier += 1;

		TChaine chNomFichier = tcDossierFichier;
		
		chNomFichier |= "erripk";
		chNomFichier |= dwNumeroFichier;
		chNomFichier |= ".txt";

		if (chNomFichier.Longueur () >= MAX_PATH)
		{
			ReleaseMutex (hmxNumeroFichier);
			RegCloseKey (hkFichierErreurs);
			cout << "Le nom du fichier d'erreurs est trop long pour tre cr lors de l'impression du fichier "
				  << chNomFichierImpression << " sur l'imprimante " << chNomImprimante << ".\n";
			return;
		}
		ofErreur.open (TTamponCaracteres (chNomFichier, ftcASCIIZ),
							ios::out | ios::noreplace);
	} while (ofErreur.fail ());
	RegSetValueEx (hkFichierErreurs, tcValeurNumero, 0, REG_DWORD,
						(BYTE*) &dwNumeroFichier, sizeof (dwNumeroFichier));
	ReleaseMutex (hmxNumeroFichier);

	SYSTEMTIME systemtime;

	GetLocalTime (&systemtime);
	ofErreur << systemtime.wDay << '/' << setfill ('0') << setw (2) << systemtime.wMonth << '/' << systemtime.wYear << '\n'
	  			<< systemtime.wHour << ':' << setw (2) << systemtime.wMinute << ':' << setw (2) << systemtime.wSecond << '\n'
			  	<< chNomImprimante << '\n'
			  	<< chNomFichierImpression;
	RegCloseKey (hkFichierErreurs);
}

int SelectionPage ()
// Slection des nouveaux paramtres d'impression  la page (taille, orientation, bac et copies)
{
	// Copies
	short sNouveauNombreCopies = sNombreCopies;
	short sCopiesAssemblees		= short (DMCOLLATE_FALSE);

	cppCourant = cppPasCopies;
	if (sNombreCopies > 1)
	{
		if ((dwDevModeFieldsPossibles & DM_COPIES) != 0 && ((dwDevModeFieldsPossibles & DM_COLLATE) != 0 || !bCopiesAssemblees))
		{
			sCopiesAssemblees = (bCopiesAssemblees) ? (short (DMCOLLATE_TRUE)) : (short (DMCOLLATE_FALSE));
		}
		else
		{
			sNouveauNombreCopies = 1;
			cppCourant = (bCopiesAssemblees) ? (cppCopiesAssemblees) : (cppCopiesALaSuite);
		}
	}

	// Slection des paramtres de page
	int iRetour = SelectionPage (sNumeroPapier, sLargeurPapier, sHauteurPapier,
										  sOrientationImpression, sNumeroBac,
										  sNouveauNombreCopies, sCopiesAssemblees);
	if (iRetour) return iRetour;

	// Calcul des zones imprimables et des dcalages
	iHauteurImprimable = 10 * sHauteurPapier;
	iLargeurImprimable = 10 * sLargeurPapier;
	{	//  Horizontal
		int iLargeurPossible = GetDeviceCaps (hdcImprimante, HORZRES);
		int iLargeurTotale	= GetDeviceCaps (hdcImprimante, PHYSICALWIDTH);
		int iMargeMinimum		= GetDeviceCaps (hdcImprimante, PHYSICALOFFSETX);
		int iPointsParPouce	= GetDeviceCaps (hdcImprimante, LOGPIXELSX);

		iDecalageX = (sMargeGauche) ? (sMargeGauche * 10 - iMargeMinimum * 2540 / iPointsParPouce) : (0);
		iLargeurImprimable -= iDecalageX + ((sMargeDroite) ? (sMargeDroite * 10 + iMargeMinimum * 2540 / iPointsParPouce) :
										 ((iLargeurTotale - iLargeurPossible) * 2540 / iPointsParPouce));
	}

	{	//  Vertical
		int iHauteurPossible = GetDeviceCaps (hdcImprimante, VERTRES);
		int iHauteurTotale	= GetDeviceCaps (hdcImprimante, PHYSICALHEIGHT);
		int iMargeMinimum		= GetDeviceCaps (hdcImprimante, PHYSICALOFFSETY);
		int iPointsParPouce	= GetDeviceCaps (hdcImprimante, LOGPIXELSY);

		iDecalageY = (sMargeHaut) ? (sMargeHaut * 10 - iMargeMinimum * 2540 / iPointsParPouce) : (0);
		iHauteurImprimable -= iDecalageY + ((sMargeBas) ? (sMargeBas * 10 + iMargeMinimum * 2540 / iPointsParPouce) :
										 ((iHauteurTotale - iHauteurPossible) * 2540 / iPointsParPouce));
	}
	hdcSortie = 0;
	iPositionX = iPositionY = 0; uiCaractereX = 0;
	bChangePage = FALSE;
	return 0;
}

int SelectionPage (short sNouveauNumeroPapier, short sNouvelleLargeurPapier,
						 short sNouvelleHauteurPapier,
						 short sNouvelleOrientationImpression,
						 short sNouveauNumeroBac, short sNouveauNombreCopies,
						 short sCopiesAssemblees)
{
	DEVMODE devmode;

	TTamponCaracteres tampcarNomImprimante (chNomImprimante, ftcASCIIZ);	
	strncpy ((char*) devmode.dmDeviceName, tampcarNomImprimante, CCHDEVICENAME);
	devmode.dmSpecVersion = WINVER;
	devmode.dmDriverVersion = 0;
	devmode.dmSize = sizeof (DEVMODE);
	devmode.dmFields = 0;

	// Taille du papier

	if (sNouveauNumeroPapier)
	{
		devmode.dmFields |= DM_PAPERSIZE;
		devmode.dmPaperSize = sNouveauNumeroPapier;
	}
	else if (bPapierPersoPossible)
	{
		devmode.dmFields |= DM_PAPERLENGTH | DM_PAPERWIDTH;
		devmode.dmPaperLength = sNouvelleHauteurPapier;
		devmode.dmPaperWidth = sNouvelleLargeurPapier;
	}

	// Orientation
	if ((dwDevModeFieldsPossibles & DM_ORIENTATION) != 0)
	{
		devmode.dmFields |= DM_ORIENTATION;
		devmode.dmOrientation = sNouvelleOrientationImpression;
	}

	// Bac
	if ((dwDevModeFieldsPossibles & DM_DEFAULTSOURCE) != 0 && sNouveauNumeroBac)
	{
		devmode.dmFields |= DM_DEFAULTSOURCE;
		devmode.dmDefaultSource = sNouveauNumeroBac;
	}

	// Copies
	if (sNouveauNombreCopies > 1)
	{
		devmode.dmFields |= DM_COPIES;
		devmode.dmCopies = sNouveauNombreCopies;
		if ((dwDevModeFieldsPossibles & DM_COLLATE) != 0)
		{
			devmode.dmFields |= DM_COLLATE;
			devmode.dmCollate = sCopiesAssemblees;
		}
	}

	// Initialisation du device context de l'imprimante pour le format de page
//	cout << "ResetDC\n";
	if (!ResetDC (hdcImprimante, &devmode))
	{
		EnregistreMessageErreur ("Il n'est pas possible d'initialiser l'imprimante avec le format de page demand");
		return -4;
	}
	return 0;
}

int SelectionPolice ()
{	// Slectionne la police de caractres
// Toutes les version de Windows ne donnent pas le mme rsultat :
//   - Avec Windows ME et la BJC-70 il y a 81 caractres au lieu de 80 demands et 135 au lieu de 132 (hauteur multiplis
//		 par 1.25 ou 1.5).
//   - Avec Windows 2000 Pro et la BJ-200ex ou la BJC-70 il y a toujours 81 caractres au lieu de 80 demands mais il y a
//     bien les 132 caractres demands.
//   - Sous Windows 2000 Pro il est ncessaire de rechercher la meilleur largeur lorsque la hauteur est multiplie alors que
//		 sous Windows ME cela ne change rien.
	LOGFONT logfont;
	HFONT hfAnc, hfNouv;
	TEXTMETRIC tmPolice;

	logfont.lfWidth = 0;	// Largeur par dfaut
	logfont.lfEscapement = 0;
	logfont.lfOrientation = 0;
	logfont.lfWeight = iGrasPolice;
	logfont.lfItalic = BYTE (bItaliquePolice);
	logfont.lfUnderline = BYTE (bSoulignePolice);
	logfont.lfStrikeOut = FALSE;
	logfont.lfCharSet = ANSI_CHARSET;
	logfont.lfOutPrecision = OUT_DEFAULT_PRECIS;
	logfont.lfClipPrecision = CLIP_DEFAULT_PRECIS;
	logfont.lfQuality = DEFAULT_QUALITY;
	logfont.lfPitchAndFamily = FIXED_PITCH | FF_DONTCARE;
	strncpy (logfont.lfFaceName, TTamponCaracteres (chNomPolice, ftcASCIIZ),
				LF_FACESIZE);

	int iHauteurMin = 0;
	int iHauteurMax = iHauteurImprimable;
	int iLargeurMin = 0;

	do
	{
		logfont.lfHeight = (iHauteurMin + iHauteurMax) / 2;
		hfNouv = CreateFontIndirect (&logfont);
		if (!hfNouv)
		{
			break;
		}
		hfAnc = HFONT (SelectObject (hdcImprimante, hfNouv));
		if (!hfAnc)
		{
			DeleteObject (hfNouv);
			break;
		}
		BOOL bErreur = !GetTextMetrics (hdcImprimante, &tmPolice);

		DeleteObject (SelectObject (hdcImprimante, hfAnc));
		if (bErreur)
		{
			break;
		}
		if ((iCaracteresParLigne) ?
			 (tmPolice.tmAveCharWidth * iCaracteresParLigne > iLargeurImprimable) :
			 (tmPolice.tmAveCharWidth > iLargeurPolice))
		{
			iHauteurMax = logfont.lfHeight;
		}
		else
		{
			iHauteurMin = logfont.lfHeight;
			iLargeurMin = tmPolice.tmAveCharWidth;
		}
	} while (iHauteurMax > iHauteurMin + 1);
	if (iHauteurMax <= iHauteurMin + 1)
	{
		if (iMultipleHauteurPolice == 1000)
		{	// Hauteur par dfaut
			logfont.lfHeight = iHauteurMin;
		}
		else
		{
			logfont.lfHeight = (iMultipleHauteurPolice) ? ((iHauteurMin * iMultipleHauteurPolice) / 1000) : (iHauteurPolice);
			logfont.lfWidth = iLargeurMin;

			int iLargeurMin = 0;
			int iLargeurMax = iLargeurImprimable;

			do
			{
				logfont.lfWidth = (iLargeurMin + iLargeurMax) / 2;
				hfNouv = CreateFontIndirect (&logfont);
				if (!hfNouv)
				{
					break;
				}
				hfAnc = HFONT (SelectObject (hdcImprimante, hfNouv));
				if (!hfAnc)
				{
					DeleteObject (hfNouv);
					break;
				}
				BOOL bErreur = !GetTextMetrics (hdcImprimante, &tmPolice);

				DeleteObject (SelectObject (hdcImprimante, hfAnc));
				if (bErreur)
				{
					break;
				}
				if ((iCaracteresParLigne) ?
					 (tmPolice.tmAveCharWidth * iCaracteresParLigne > iLargeurImprimable) :
					 (tmPolice.tmAveCharWidth > iLargeurPolice))
				{
					iLargeurMax = logfont.lfWidth;
				}
				else
				{
					iLargeurMin = logfont.lfWidth;
				}
			} while (iLargeurMax > iLargeurMin + 1);
			if (iLargeurMax <= iLargeurMin + 1)
			{
				logfont.lfWidth = iLargeurMin;
			}
			else
			{
				logfont.lfHeight = 0;
			}
		}
		if (logfont.lfHeight)
		{
/*			cerr << "Taille police : mh " << iMultipleHauteurPolice << ", "
											"h " << iHauteurPolice << ", "
											"cpl " << iCaracteresParLigne << ", "
											"l " << iLargeurPolice << ", "
											"lfh " << logfont.lfHeight << ", "
											"lfw " << logfont.lfWidth << ".\n";*/
			hfNouv = CreateFontIndirect (&logfont);
		}
		else
		{
			hfNouv = 0;
		}
	}
	else
	{	// Impossible de dterminer la taille de la police
		hfNouv = 0;
	}
	if (hfNouv)
	{
		if ((hfAnc = HFONT (SelectObject (hdcSortie, hfNouv))) != 0 &&
			 GetTextMetrics (hdcSortie, &tmPolice))
		{
			if (hfAnc == hfCourante)
			{	// Ne dtruit pas la police par dfaut
				DeleteObject (hfCourante);
			}
			else if (!hfDefaut)
			{
				hfDefaut = hfAnc;
			}
			hfCourante = hfNouv;
			iLargeurCaractere = tmPolice.tmAveCharWidth;
			if (iInterligneMultiple)
			{
				iInterligne = tmPolice.tmHeight * iInterligneMultiple;
			}
/*			cerr << "Slection : l " << iLargeurCaractere << ", "
									  "i " << iInterligne << ".\n";*/
		}
		else
		{
			if (hfAnc)
			{
				SelectObject (hdcSortie, hfAnc);
			}
			DeleteObject (hfNouv);

			EnregistreMessageErreur ("Il n'est pas possible de slectionner la police " | chNomPolice | ", la police par "
											 "dfaut est utilise");
		}
	}
	else
	{
		EnregistreMessageErreur (TChaine ("La polise ") | chNomPolice | " n'existe pas, la police par dfaut est utilise");
	}
	bChangePolice = FALSE;
	return 0;
}

int main (int argc, char* argv[], char* /*env*/[])
{
// Lecture de la ligne de commande
	if (!LectureLigneCommande (argc, argv))
	{
		int codeRetour = 0;

		if (argc == 2 && TChaine (argv [1]).Majuscules () == TChaine ("--LICENCE"))
		{
			cout << "EN FRANCAIS :\n"
					  "\n"
					  "Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon\n"
					  "les termes de la Licence Publique Gnrale GNU publie par la Free Software\n"
					  "Foundation (version 2 ou bien toute autre version ultrieure choisie par\n"
					  "vous).\n"
					  "\n"
					  "Ce programme est distribu car potentiellement utile, mais SANS AUCUNE\n"
					  "GARANTIE, ni explicite ni implicite, y compris les garanties de\n"
					  "commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la\n"
					  "Licence Publique Gnrale GNU pour plus de dtails.\n"
					  "\n"
					  "Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme\n"
					  "temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software\n"
					  "Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,\n"
					  "tats-Unis.\n"
					  "----------------------------------------------------------------------------\n";
		}
		else
		{
			if (argc > 1 && (argc != 2 || strcmp (argv [1], "-?") != 0))
			{
				codeRetour = -2;
				cerr << "Les paramtres de la ligne de commande sont incorrects.\n"
						  "\n";
			}
			cerr << "ImprPick, Copyright (c) 2000 et 2001, Thierry MARTIN.\n"
					  "Ce programme est libre sous licence GPL.\n"
					  "\n"
					  "La syntaxe est la suivante :\n"
					  "\tImprPick imprimante fichier\n"
					  "Le fichier est supprim aprs l'impression.\n"
					  "\n"
					  "La commande \"ImprPick --licence\" permet d'afficher la licence.\n";
		}
		return codeRetour;
	}

// Dossier pour les fichiers temporaires
	if (!GetTempPath (MAX_PATH, tcDossierTEMP))
	{
		DWORD dwErreur = GetLastError ();

		EnregistreMessageErreur (TChaine ("Erreur numro ") | dwErreur | " lors de la recherche du nom du dossier pour "
										 "les fichiers temporaires");
		return -1;
	}

// Ouverture du fichier  imprimer (en entre)
	TTamponCaracteres tampcarNomFichier (chNomFichierImpression, ftcASCIIZ);

	ifImpression.open (tampcarNomFichier, ios::in | ios::nocreate | ios::binary);
	if (!ifImpression)
	{
		EnregistreMessageErreur ("Erreur lors de l'ouverture du fichier d'impression");
		return -1;
	}

// Lecture des paramtres de l'imprimante
	TTamponCaracteres tampcarNomImprimante (chNomImprimante, ftcASCIIZ);
	hdcImprimante = CreateDC ("WINSPOOL", tampcarNomImprimante, NULL, NULL);
	if (!hdcImprimante)
	{
		EnregistreMessageErreur ("L'imprimante n'existe pas");
		return -3;
	}
	if (!SetMapMode (hdcImprimante, MM_HIMETRIC))
	{
		EnregistreMessageErreur ("L'unit de mesure MM_HIMETRIC ne peux pas tre applique");
		return -4;
	}
	dwDevModeFieldsPossibles = DeviceCapabilities (tampcarNomImprimante, NULL, DC_FIELDS, NULL, NULL);
	dwOrientationPaysage = DeviceCapabilities (tampcarNomImprimante, NULL, DC_ORIENTATION, NULL, NULL);

	// Taille limite du papier personnalis
	bPapierPersoPossible = (dwDevModeFieldsPossibles & (DM_PAPERLENGTH | DM_PAPERWIDTH)) == (DM_PAPERLENGTH | DM_PAPERWIDTH);
	if (bPapierPersoPossible)
	{
		DWORD dwTaillePapier = DeviceCapabilities (tampcarNomImprimante, NULL, DC_MINEXTENT, NULL, NULL);
		iHauteurMinPapier = HIWORD (dwTaillePapier); iLargeurMinPapier = LOWORD (dwTaillePapier);
		dwTaillePapier = DeviceCapabilities (tampcarNomImprimante, NULL, DC_MAXEXTENT, NULL, NULL);
		iHauteurMaxPapier = HIWORD (dwTaillePapier); iLargeurMaxPapier = LOWORD (dwTaillePapier);
	}

	// Liste des formats de papier
	if (dwDevModeFieldsPossibles & DM_PAPERSIZE)
	{
		dwNombrePapiersDefinis = DeviceCapabilities (tampcarNomImprimante, NULL, DC_PAPERNAMES, NULL, NULL);
		if (dwNombrePapiersDefinis)
		{
			DWORD dwPapier;

			// Numro des papiers
			if (DeviceCapabilities (tampcarNomImprimante, NULL, DC_PAPERS, NULL, NULL) < dwNombrePapiersDefinis)
			{
				EnregistreMessageErreur ("La dfinition des papiers de l'imprimante est incorrecte");
				return -3;
			}
			tsNumeroPapierDefini.Longueur (dwNombrePapiersDefinis);
			DeviceCapabilities (tampcarNomImprimante, NULL, DC_PAPERS, (char*) &tsNumeroPapierDefini [0], NULL);

			// Taille des papiers
			if (DeviceCapabilities (tampcarNomImprimante, NULL, DC_PAPERSIZE, NULL, NULL) < dwNombrePapiersDefinis)
			{
				EnregistreMessageErreur ("La dfinition des papiers de l'imprimante est incorrecte");
				return -3;
			}
			tpoTaillePapierDefini.Longueur (dwNombrePapiersDefinis);
			DeviceCapabilities (tampcarNomImprimante, NULL, DC_PAPERSIZE, (char*) &tpoTaillePapierDefini [0], NULL);

			// Nom des papiers
			char* tcNomPapiers = new char [64 * dwNombrePapiersDefinis];
			TChaine chNomPapierStandard ("LETTRE US\xFE"									// 1
												  "PETITE LETTRE US\xFE"
												  "TABLOID US\xFE"
												  "GRAND LIVRE US\xFE"
												  "LEGAL US\xFE"									// 5
												  "DEPOSITION US\xFE"
												  "EXECUTIVE US\xFE"
												  "A3\xFE"
												  "A4\xFE"
												  "PETIT A4\xFE"									// 10
												  "A5\xFE"
												  "B4 (JIS)\xFE"
												  "B5 (JIS)\xFE"
												  "FOLIO US\xFE"
												  "IN-QUARTO\xFE"									// 15
												  "10 X 14 POUCES\xFE"
												  "11 X 17 POUCES\xFE"
												  "NOTE\xFE"
												  "ENVELOPPE US #9\xFE"
												  "ENVELOPPE US #10\xFE"						// 20
												  "ENVELOPPE US #11\xFE"
												  "ENVELOPPE US #12\xFE"
												  "ENVELOPPE US #14\xFE"
												  "FEUILLE TAILLE B\xFE"
												  "FEUILLE TAILLE C\xFE"						// 25
												  "FEUILLE TAILLE E\xFE"
												  "ENVELOPPE DL\xFE"
												  "ENVELOPPE C5\xFE"
												  "ENVELOPPE C3\xFE"
												  "ENVELOPPE C4\xFE"								// 30
												  "ENVELOPPE C6\xFE"
												  "ENVELOPPE C65\xFE"
												  "ENVELOPPE B4\xFE"
												  "ENVELOPPE B5\xFE"
												  "ENVELOPPE B6\xFE"								// 35
												  "ENVELOPPE 11 X 23 CM\xFE"
												  "ENVELOPPE MONARCH\xFE"
												  "ENVELOPPE 6 3/4\xFE"
												  "COURRIER PLIE STANDARD US\xFE"
												  "COURRIER PLIE STANDARD ALLEMAND\xFE"	// 40
												  "COURRIER PLIE LEGAL ALLEMAND\xFE"
												  "B4 (ISO)\xFE"
												  "CARTE POSTALE JAPONAISE\xFE"
												  "9 X 11 POUCES\xFE"
												  "10 X 11 POUCES\xFE"							// 45
												  "15 X 11 POUCES\xFE"
												  "ENVELOPPE D'INVITATION\xFE"
												  "\xFE"
												  "\xFE"
												  "LETTRE US EXTRA\xFE"							// 50
												  "LEGAL US EXTRA\xFE"
												  "TABLOID US EXTRA\xFE"
												  "A4 EXTRA\xFE"
												  "LETTRE US TRANSVERSAL\xFE"
												  "A4 TRANSVERSAL\xFE"							// 55
												  "LETTRE US EXTRA TRANSVERSAL\xFE"
												  "SUPERA/SUPERA/4A\xFE"
												  "SUPERB/SUPERB/A3\xFE"
												  "LETTRE US PLUS\xFE"
												  "A4 PLUS\xFE"									// 60
												  "A5 TRANSVERSAL\xFE"
												  "B5 (JIS) TRANSVERSAL\xFE"
												  "A3 EXTRA\xFE"
												  "A5 EXTRA\xFE"
												  "B5 (ISO) EXTRA\xFE"							// 65
												  "A2\xFE"
												  "A3 TRANSVERSAL\xFE"
												  "A3 EXTRA TRANSVERSAL");						// 68

			DeviceCapabilities (tampcarNomImprimante, NULL, DC_PAPERNAMES, tcNomPapiers, NULL);
			for (dwPapier = 0 ; dwPapier < dwNombrePapiersDefinis ; ++dwPapier)
			{
				TChaine chNomPapier = TChaine (&tcNomPapiers [64 * dwPapier]).Majuscules ().AjusteBlancs ();
				if (!chNomPapier.Longueur ())
				{
					short sNumeroPapier = tsNumeroPapierDefini [dwPapier];
					chNomPapier = chNomPapierStandard (sNumeroPapier);
					if (!chNomPapier.Longueur ())
					{
						chNomPapier = TChaine ("PAPIER NUMERO ") | sNumeroPapier;
					}
				}
				chNomPapierDefini (dwPapier + 1) = chNomPapier;
			}
			delete tcNomPapiers;
		}
	}
	else
	{
		dwNombrePapiersDefinis = 0;
	}

	// Liste des bacs
	if (dwDevModeFieldsPossibles & DM_DEFAULTSOURCE)
	{
		dwNombreBacsDefinis = DeviceCapabilities (tampcarNomImprimante, NULL, DC_BINNAMES, NULL, NULL);
		if (dwNombreBacsDefinis)
		{
			DWORD Longueur = DeviceCapabilities (tampcarNomImprimante, NULL, DC_BINS, NULL, NULL);
			if (Longueur < dwNombreBacsDefinis)
			{
				EnregistreMessageErreur ("La dfinition des bacs de l'imprimante est incorrecte");
				return -3;
			}
			tsNumeroBacDefini.Longueur (Longueur);
			DeviceCapabilities (tampcarNomImprimante, NULL, DC_BINS, (char*) &tsNumeroBacDefini [0], NULL);

			char* nomBacCap = new char [24 * dwNombreBacsDefinis];
			DWORD dwBac;
			TChaine chNomBacStandard ("BAC SUPERIEUR\xFE"						// 1
											  "BAC INFERIEUR\xFE"
											  "BAC DU MILIEU\xFE"
											  "ALIMENTATION MANUELLE\xFE"
											  "ENVELOPPE\xFE"								// 5
											  "ALIMENTATION ENVELOPPE\xFE"
											  "SELECTION AUTOMATIQUE\xFE"
											  "ENTRAINEUR A PICOT\xFE"
											  "PETIT FORMAT\xFE"
											  "GRAND FORMAT\xFE"							// 10
											  "BAC DE GRANDE CAPACITE\xFE"
											  "\xFE"											// 12
											  "\xFE"											// 13
											  "CASSETTE\xFE"
											  "ALIMENTATION EN FORMULAIRE\xFE");	// 15

			DeviceCapabilities (tampcarNomImprimante, NULL, DC_BINNAMES, nomBacCap, NULL);
			for (dwBac = 0; dwBac < dwNombreBacsDefinis; ++dwBac)
			{
				TChaine chNomBac = TChaine (nomBacCap [24 * dwBac]).Majuscules ().AjusteBlancs ();
				if (!chNomBac.Longueur ())
				{
					short sNumeroBac = tsNumeroBacDefini [dwBac];
					chNomBac = chNomBacStandard (sNumeroBac);
					if (!chNomBac.Longueur ())
					{
						chNomBac = TChaine ("BAC NUMERO ") | sNumeroBac;
					}
				}
				chNomBacDefini (dwBac + 1) = chNomBac;
			}
			delete nomBacCap;
		}
	}
	else
	{
		dwNombreBacsDefinis = 0;
	}

// Initialisation des variables d'impression
	chTitreDocument = "";
	ppgcopDernierePage = 0;
	ppgcopPremierePage = 0;
	sOrientationImpression = DMORIENT_PORTRAIT;
	bCopiesAssemblees = TRUE;
	sNombreCopies = 1;
	sMargeBas = sMargeDroite = sMargeGauche = sMargeHaut = 0;
	sNumeroBac = 0;
	iPositionX = iPositionY = 0; uiCaractereX = 0;
	iInterligneMultiple = 1;
	iCaracteresParLigne = 80;
	iMultipleHauteurPolice = 1000;
	chNomPolice = "Courier New";
	iGrasPolice = FW_DONTCARE;
	bItaliquePolice = FALSE;
	bSoulignePolice = FALSE;

	// Slection du papier
	sNumeroPapier = 0;
	sHauteurPapier = sHauteurPapierDefaut;
	sLargeurPapier = sLargeurPapierDefaut;
	if (dwNombrePapiersDefinis)
	{
		DWORD dwPapier;

		for (dwPapier = 0; dwPapier < dwNombrePapiersDefinis; ++dwPapier)
		{
			if (tsNumeroPapierDefini [dwPapier] == DMPAPER_A4)
			{
				sNumeroPapier = DMPAPER_A4;
				sHauteurPapier = short (tpoTaillePapierDefini [dwPapier].y);
				sLargeurPapier = short (tpoTaillePapierDefini [dwPapier].x);
				break;
			}
		}
	}
	bChangePage = TRUE;
	bChangePolice = TRUE;
	bDocumentOuvert = FALSE;
	bModeCommande = FALSE;
	bPageVide = TRUE;
	ppgcopPremierePage = ppgcopDernierePage = 0;
	bErreurSuppFichierTemp = FALSE;

	// Lancement de l'impression
	int iRetour = ImprimeFichier ();

	// Fin de l'impression
	if (bModeCommande) FinCommande ();
	int iRetourImprime = ImprimePage ();
	if (!iRetour)
	{
		iRetour = iRetourImprime;
		if (!iRetour) iRetour = ImprimeCopies ();
	}
	if (bDocumentOuvert)
	{
//		cout << "EndDoc\n";
		if (EndDoc (hdcImprimante) <= 0)
		{
			DWORD dwErreur = GetLastError ();

			EnregistreMessageErreur (TChaine ("Erreur numro ") | dwErreur | "  la fin de l'impression du fichier");
			if (!iRetour) iRetour = -4;
		}
	}
	if (cppCourant && hdcSortie != hdcImprimante)
	{
		DeleteEnhMetaFile (CloseEnhMetaFile (hdcSortie));
	}
	if (!DeleteDC (hdcImprimante))
	{
		DWORD dwErreur = GetLastError ();

		EnregistreMessageErreur (TChaine ("Erreur numro ") | dwErreur | " lors de la fermeture du device context de "
										 "l'imprimante");
		if (!iRetour) iRetour = -4;
	}
	while (ppgcopPremierePage)
	{
		TPageCopie* ppgcopSuivante = ppgcopPremierePage->ppgcopSuivante;
		TTamponCaracteres tampcarNomFichier (ppgcopPremierePage->chNomFichier, ftcASCIIZ);

		if (!DeleteFile (tampcarNomFichier) &&
			 GetLastError () != ERROR_FILE_NOT_FOUND)
		{
			bErreurSuppFichierTemp = TRUE;
		}
		delete ppgcopPremierePage;
		ppgcopPremierePage = ppgcopSuivante;
	}
	if (bErreurSuppFichierTemp)
	{
		EnregistreMessageErreur ("Certains fichiers temporaires n'ont pas t "
										 "supprims");
	}
	ifImpression.close ();
	if (bAucuneErreur && !iRetour)
	{
		if (!DeleteFile (tampcarNomFichier))
		{
			DWORD dwErreur = GetLastError ();

			EnregistreMessageErreur (TChaine ("Erreur numro ") | dwErreur |
											 " lors de la suppression du fichier " |
											 TChaine (tampcarNomFichier) |
											 " aprs impression");
		}
	}
	else
	{
		EnregistreMessageErreur (TChaine ("Le fichier ") |
										 TChaine (tampcarNomFichier) |
										 " n'est pas supprim aprs impression");
	}
	return iRetour;
}
