// ListePolice - Affiche la liste des polices utilisables par ImprPick (polices  champ fixe disposant des caractres
// 				  semi-graphiques UNICODE).
// Copyright (c) 2001, Thierry MARTIN.
// Version #1.00.
// Dernire version termine le mardi 31 juillet 2001.

// Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon
// les termes de la Licence Publique Gnrale GNU publie par la Free Software
// Foundation (version 2 ou bien toute autre version ultrieure choisie par
// vous).
//
// Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
// GARANTIE, ni explicite ni implicite, y compris les garanties de
// commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
// Licence Publique Gnrale GNU pour plus de dtails.
//
// Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
// temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
// tats-Unis.

// Vous pouvez me joindre par e-mail  : imprpick@martin-thierry.nom.fr

// Versions :
//	  #1.00 : 31/07/01 : Affiche les polices  champ fixe. Il faut ensuite faire un essai d'impression pour contrler si les
//	  							semi-graphiques sont disponibles et si les caractres italiques et gras sont de la mme largeur.

// J'ai dvelopp ce programme en utilisant :
//   Le compilateur GCC version 2.95.2.
//   L'environnement CygWin32 version 1.3.2 disponible  http://www.cygwin.com/ (comprend GCC).

#include <Windows.H>
#include <IOStream.H>

int CALLBACK ListePoliceCallBack (const ENUMLOGFONTEX* enumlogfont,
											 const NEWTEXTMETRICEX* textmetric,
											 long unsigned int iFontType, LPARAM param)
{
	if (iFontType & TRUETYPE_FONTTYPE &&
		 (enumlogfont->elfLogFont.lfPitchAndFamily & (FIXED_PITCH | VARIABLE_PITCH)) == FIXED_PITCH)
	{
		cout << enumlogfont->elfFullName << " / " << enumlogfont->elfStyle <<
				  " / " << enumlogfont->elfScript << "\n";
	}
	return 1;
}

int main ()
{
	HDC hdc;

	hdc = CreateDC ("DISPLAY", NULL, NULL, NULL);
	if (hdc == NULL)
	{
		cerr << "Impossible de crer un Device Context.\n";
		return -1;
	}

	LOGFONT logfont;

	logfont.lfHeight = 0;
	logfont.lfWidth = 0;
	logfont.lfEscapement = 0;
	logfont.lfOrientation = 0;
	logfont.lfWeight = 0;
	logfont.lfItalic = 0;
	logfont.lfUnderline = 0;
	logfont.lfStrikeOut = 0;
	logfont.lfCharSet = ANSI_CHARSET;
	logfont.lfOutPrecision = 0;
	logfont.lfClipPrecision = 0;
	logfont.lfQuality = 0;
	logfont.lfPitchAndFamily = 0;
	logfont.lfFaceName [0] = '\0';
	EnumFontFamiliesEx (hdc, &logfont, FONTENUMPROC (&ListePoliceCallBack), 0,
							  0);
	DeleteDC (hdc);
	return 0;
}
